<?php

namespace Modules\User\Providers;

use Illuminate\Foundation\Support\Providers\RouteServiceProvider as ServiceProvider;
use Illuminate\Support\Facades\Route;

class RouteServiceProvider extends ServiceProvider
{

    /**
     * @var string $moduleName
     */
    protected string $moduleName = 'User';

    /**
     * The module namespace to assume when generating URLs to actions.
     * @var string
     */
    protected string $moduleNamespace = 'Modules\User\Http\Controllers';

    /**
     * Called before routes are registered.
     * Register any model bindings or pattern based filters.
     * @return void
     */
    public function boot()
    {
        parent::boot();
    }

    /**
     * Define the routes for the application.
     * @return void
     */
    public function map()
    {
        $this->mapAdminRoutes();
        $this->mapApiRoutes();
    }

    protected function mapApiRoutes()
    {
        Route::as(config('api.route.as'))
             ->domain(config('api.route.domain'))
             ->middleware(config('api.route.middleware'))
             ->namespace($this->moduleNamespace . '\\Api')
             ->prefix(config('api.route.prefix') . '/user')
             ->group(module_path($this->moduleName, 'Routes/api.php'));
    }

    protected function mapAdminRoutes()
    {
        Route::as(config('admin.route.as'))
             ->domain(config('admin.route.domain'))
             ->middleware(config('admin.route.middleware'))
             ->namespace($this->moduleNamespace . '\\Admin')
             ->prefix(config('admin.route.prefix'))
             ->group(module_path($this->moduleName, 'Routes/admin.php'));
    }

}
